# ApplicationFramework
TKLCAF
TDataStd

# TDataStd_RealArray Class Reference

A framework for an attribute composed of a real number array.
.

`#include <TDataStd_RealArray.hxx>`

Inheritance diagram for TDataStd_RealArray:

[legend]

## Public Member Functions

Standard_EXPORT void | Init (const Standard_Integer lower, const Standard_Integer upper)
| Initialize the inner array with bounds from <lower> to <upper> .
Standard_EXPORT void | SetValue (const Standard_Integer Index, const Standard_Real Value)
| Sets the <index>th element of the array to <value> .
Standard_EXPORT Standard_Real | Value (const Standard_Integer Index) const
| Return the value of the <index>th element of the array .
Standard_Real | operator() (const Standard_Integer Index) const
Standard_EXPORT Standard_Integer | Lower () const
| Returns the lower boundary of the array. .
Standard_EXPORT Standard_Integer | Upper () const
| Returns the upper boundary of the array. .
Standard_EXPORT Standard_Integer | Length () const
| Returns the number of elements of the array of reals in terms of the number of elements it contains. .
Standard_EXPORT void | ChangeArray (const Handle(TColStd_HArray1OfReal)&newArray, const Standard_Boolean isCheckItems=Standard_True)
| Sets the inner array <myvalue> of the RealArray attribute to <newarray>. If value of <newarray> differs from <myvalue>, Backup performed and myValue refers to new instance of HArray1OfReal that holds <newarray> values If <ischeckitems> equal True each item of <newarray> will be checked with each item of <myvalue> for coincidence (to avoid backup). .
const Handle_TColStd_HArray1OfReal | Array () const
| Returns the handle of this array of reals. .
Standard_Boolean | GetDelta () const
void | SetDelta (const Standard_Boolean isDelta)
| for internal use only!
Standard_EXPORT | TDataStd_RealArray ()
Standard_EXPORT const Standard_GUID & | ID () const
| Returns the ID of the attribute. .
Standard_EXPORT void | Restore (const Handle(TDF_Attribute)&With)
| Restores the backuped contents from <anattribute> into this one. It is used when aborting a transaction. .
Standard_EXPORT Handle_TDF_Attribute | NewEmpty () const
| Returns an new empty attribute from the good end type. It is used by the copy algorithm. .
Standard_EXPORT void | Paste (const Handle(TDF_Attribute)&Into, const Handle(TDF_RelocationTable)&RT) const
| Note. Uses inside ChangeArray() method .
virtual Standard_EXPORT Standard_OStream & | Dump (Standard_OStream &anOS) const
| Dumps the minimum information about <me> on <astream>. .
virtual Standard_EXPORT Handle_TDF_DeltaOnModification | DeltaOnModification (const Handle(TDF_Attribute)&anOldAttribute) const
| Makes a DeltaOnModification between <me> and <anoldattribute>. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT const Standard_GUID & | GetID ()
| class methods ============= //! Returns the GUID for arrays of reals.
static Standard_EXPORT Handle_TDataStd_RealArray | Set (const TDF_Label &label, const Standard_Integer lower, const Standard_Integer upper, const Standard_Boolean isDelta=Standard_False)
| Finds or creates on the <label> a real array attribute with the specified <lower> and <upper> boundaries. If attribute is already set, all input parameters are refused and the found attribute is returned. .

## Private Member Functions

void | RemoveArray ()

## Private Attributes

Handle_TColStd_HArray1OfReal | myValue
Standard_Boolean | myIsDelta

## Constructor & Destructor Documentation

Standard_EXPORT TDataStd_RealArray::TDataStd_RealArray | ( |  | ) |

## Member Function Documentation

const Handle_TColStd_HArray1OfReal TDataStd_RealArray::Array | ( |  | ) | const

Standard_EXPORT void TDataStd_RealArray::ChangeArray | ( | const Handle(TColStd_HArray1OfReal)& | newArray,
|  | const Standard_Boolean | isCheckItems = `Standard_True`
| ) |

virtual Standard_EXPORT Handle_TDF_DeltaOnModification TDataStd_RealArray::DeltaOnModification | ( | const Handle(TDF_Attribute)& | anOldAttribute | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT Standard_OStream& TDataStd_RealArray::Dump | ( | Standard_OStream & | anOS | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

Standard_Boolean TDataStd_RealArray::GetDelta | ( |  | ) | const`[inline]`

static Standard_EXPORT const Standard_GUID& TDataStd_RealArray::GetID | ( |  | ) | `[static]`

Standard_EXPORT const TDataStd_RealArray::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from TDF_Attribute.

Standard_EXPORT const Standard_GUID& TDataStd_RealArray::ID | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TDataStd_RealArray::Init | ( | const Standard_Integer | lower,
|  | const Standard_Integer | upper
| ) |

Standard_EXPORT Standard_Integer TDataStd_RealArray::Length | ( |  | ) | const

Standard_EXPORT Standard_Integer TDataStd_RealArray::Lower | ( |  | ) | const

Standard_EXPORT Handle_TDF_Attribute TDataStd_RealArray::NewEmpty | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_Real TDataStd_RealArray::operator() | ( | const Standard_Integer | Index | ) | const`[inline]`

Standard_EXPORT void TDataStd_RealArray::Paste | ( | const Handle(TDF_Attribute)& | Into,
|  | const Handle(TDF_RelocationTable)& | RT
| ) | const`[virtual]`

| Implements TDF_Attribute.

void TDataStd_RealArray::RemoveArray | ( |  | ) | `[inline, private]`

Standard_EXPORT void TDataStd_RealArray::Restore | ( | const Handle(TDF_Attribute)& | With | ) | `[virtual]`

| Implements TDF_Attribute.

static Standard_EXPORT Handle_TDataStd_RealArray TDataStd_RealArray::Set | ( | const TDF_Label & | label,
|  | const Standard_Integer | lower,
|  | const Standard_Integer | upper,
|  | const Standard_Boolean | isDelta = `Standard_False`
| ) | `[static]`

void TDataStd_RealArray::SetDelta | ( | const Standard_Boolean | isDelta | ) | `[inline]`

Standard_EXPORT void TDataStd_RealArray::SetValue | ( | const Standard_Integer | Index,
|  | const Standard_Real | Value
| ) |

Standard_EXPORT Standard_Integer TDataStd_RealArray::Upper | ( |  | ) | const

Standard_EXPORT Standard_Real TDataStd_RealArray::Value | ( | const Standard_Integer | Index | ) | const

## Field Documentation

Standard_Boolean TDataStd_RealArray::myIsDelta`[private]`

Handle_TColStd_HArray1OfReal TDataStd_RealArray::myValue`[private]`

The documentation for this class was generated from the following files:

- TDataStd_RealArray.hxx
- TDataStd_RealArray.lxx